Class = require "hump.class"
vector = require "hump.vector"
PrettyPrint = require "libs.pp.PrettyPrint"
Actor = require "actor"

Blue = Class{
    init = function(self, pos, r, level)
                Actor.init(self,pos,r,level)
                self.timer = Timer.new()
                self.timer:addPeriodic(2, function() self:gatherFood() end)
                self.timer:addPeriodic(1, function() self:beInfluenced() end)
                self.gatherSpeed = function(self)
                    return self.level * 2
                end
                self.redness = 0
                self.hitAnim = anim8.newAnimation(hitGrid('1-2',1), 0.2)
           end,
    color = "blue"
}
Blue:include(Actor)


function Blue:update(dt)
    self.timer:update(dt)
    self.hitAnim:update(dt)
    Actor.update(self,dt)
end

function Blue:draw()
    --love.graphics.setColor( 0, 0, 255, 255 )
    if self.goal then
        local d = self.goal - self.pos
        local radian = d:angleTo()
        local direction = radianToDirection(radian)
        if direction == "up" then
            self.right:draw(blueSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        elseif direction == "left" then
            self.left:draw(blueSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        elseif direction == "down" then
            self.down:draw(blueSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        elseif direction == "right" then
            self.right:draw(blueSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        else
            self.down:draw(blueSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        end
    else
        self.down:draw(redSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
    end
    --love.graphics.setColor( 255, 255, 255, 255 )
end

function Blue:gatherFood()
    for i, place in ipairs(allFoodPlaces) do
        if collide(self.pos,self:r(),place.pos,place.r) then
            local gathered = place:gather(self:gatherSpeed())
            self.group.food = self.group.food + gathered


            if gathered > 0 then
                love.audio.play(gatherS)

                local dx = love.math.random(-32,32 )
                local dy = love.math.random(-32,32 )

                drawTimer:do_for(0.4, function()
                    love.graphics.setColor( 30, 120, 30, 255 )
                    self.hitAnim:draw(hitSprite,place.pos.x - 32 + dx, place.pos.y - 32 + dy)
                    love.graphics.setColor( 255, 255, 255, 255 )
                end)
            end
        end
    end
end

function Blue:die()
    self.timer:clear()
    Actor.die(self)
end

function Blue:beInfluenced()
    local influenceRange = 30
    local reds = _.filter(self:nearActors(30), function(actor)
        return actor.color == "red"
    end)
    if #reds > 5 then
        self.redness = self.redness + Actor.convertSpeed
    end
    if self.redness > 10 then
        nomads:addMember(Red(self.pos, self.rawR, self.level))
        self:die()
    end
end

function Blue:changeJob()
    local newLevel = math.clamp(1,self.level/2,8)
    nomads:addMember(Red(self.pos, self.rawR, newLevel))
    self:die()
end


return Blue