Class = require "hump.class"
vector = require "hump.vector"
PrettyPrint = require "libs.pp.PrettyPrint"

Group = Class{
    init = function(self)
        self.member = {}
        self.food = 0

    end
}

function Group:addMember(actor)
    --don't add actor if already a member
    for i, member in ipairs(self.member) do
        if actor == member then return nil end
    end
    actor.group = self
    table.insert(self.member, actor)
end

function Group:removeMember(member)
    for i, v in ipairs(self.member) do
        if v == member then table.remove(self.member, i) end
    end
end

function Group:update(dt)
    for i, actor in ipairs(self.member) do
        actor:update(dt)
    end
end

function Group:draw()
    for i, actor in ipairs(self.member) do
        actor:draw()
    end
end

function Group:feed(actor)
    local n = actor:needs()
    if self.food > n then
        actor:eat(n)
        self.food = self.food - n
    end
end

function Group:feedAll()
    for i, member in ipairs(self.member) do
        self:feed(member)
    end
end

function Group:numRed(...)
    -- body
end

function Group:middle()
    local m = vector(0,0)
    for i, actor in ipairs(self.member) do
        m = m + actor.pos
    end
    return m/(#self.member)
end


return Group