Class = require "hump.class"
vector = require "hump.vector"
PrettyPrint = require "libs.pp.PrettyPrint"

Player = Class{
    init = function(self)
        self.focus = nil
    end
}

function Player:update(dt)
    self:drag(dt)
end

function Player:focusAt(pos)
    local found = false
    for i, actor in ipairs(playerGroup.member) do
        if pos:dist(actor.pos) < actor:r()*2 then
            self.focus = actor
            found = true
        end
    end
    if not found then
        self.focus = nil
    end
end

function Player:drag(dt)
    if self.focus and love.mouse.isDown( "r" ) then
        x, y = camera:worldCoords(love.mouse.getPosition( ))
        --self.focus:step(vector(x,y), dt)
        self.focus.pos = vector(x-16,y-10)
    end
end

return Player