Class = require "hump.class"
vector = require "hump.vector"
PrettyPrint = require "libs.pp.PrettyPrint"
Actor = require "actor"



Recruit = Class{
    init = function(self, pos, r, level)
                Actor.init(self,pos,r,level)

                local rand = math.random(0, 1)
                if rand == 1 then
                    self.color = "blue"
                else
                    self.color = "red"
                end
                self.arrow = anim8.newAnimation(arrowGrid('1-4',1), 0.1)
           end,
           recruitingDistance = 100
}
--Recruit:include(Actor)


function Recruit:update(dt)
    --self.down:update(dt)
    if not self.gone then
        for i, actor in ipairs(playerGroup.member) do
            if self.pos:dist(actor.pos) < Recruit.recruitingDistance then
                self:tryJoin()
            end
        end

    self.arrow:update(dt)
    end
end

function Recruit:draw()
    if not self.gone then
        if self.color == "red" then
            self.down:draw(redSprite, self.pos.x - 16, self.pos.y - 10)
        elseif self.color == "blue" then
            self.down:draw(blueSprite, self.pos.x - 16, self.pos.y - 10)
        end

        self.arrow:draw(arrowSprite, self.pos.x -7 , self.pos.y - 30)
    --love.graphics.draw(arrowSprite, self.pos.x - 16, self.pos.y - 20)
    end
end

function Recruit:tryJoin()
    if not self.gone then
        self:join()
    end
end

function Recruit:join()
    if self.color == "blue" then
        nomads:addMember(Blue(self.pos, self.rawR, self.level))
    elseif self.color == "red" then
        nomads:addMember(Red(self.pos, self.rawR, self.level))
    end
    love.audio.play( recruitS )

    self.gone = true    --so horrible, I want to die.
    table.removeV(recruits, self)
end

return Recruit