Class = require "hump.class"
vector = require "hump.vector"
PrettyPrint = require "libs.pp.PrettyPrint"
Actor = require "actor"



Red = Class{
    init = function(self, pos, r, level)
                Actor.init(self,pos,r,level)
                self.range = 100
                self.timer = Timer.new()
                self.timer:addPeriodic(1, function() self:fight(self:nextEnemy()) end )
                self.timer:addPeriodic(1, function() self:beInfluenced() end)
                self.blueness = 0
                self.hitAnim = anim8.newAnimation(hitGrid('1-2',1), 0.2)
           end,
    color = "red"
}
Red:include(Actor)


function Red:update(dt)
    self.timer:update(dt)
    self.hitAnim:update(dt)
    Actor.update(self,dt)
end

function Red:draw()
    --love.graphics.setColor( 255, 0, 0, 255 )
    --Actor.draw(self)
    if self.goal then
        local d = self.goal - self.pos
        local radian = d:angleTo()
        local direction = radianToDirection(radian)
        if direction == "up" then
            self.right:draw(redSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        elseif direction == "left" then
            self.left:draw(redSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        elseif direction == "down" then
            self.down:draw(redSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        elseif direction == "right" then
            self.right:draw(redSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
        end
    else
        self.down:draw(redSprite, self.pos.x - 16, self.pos.y - 10, 0, 2, 2)
    end
    --love.graphics.setColor( 255, 255, 255, 255 )
end

function Red:nextEnemy()
    local withD = _.map(enemies, function(actor)
        local d = self.pos:dist(actor.pos)
        if d <= self.range then
            return {actor = actor, d = d}
        end
    end)

    local minWithD = _.min(withD,function(t)
        return t.d
    end)

    if minWithD then return minWithD.actor else return nil end
end

function Red:fight(actor)
    if actor then
        actor:shrink(5)
        love.audio.play( hitS )

        drawTimer:do_for(0.4, function()
            self.hitAnim:draw(hitSprite,actor.pos.x - 32, actor.pos.y - 32)
        end)
    end
end

function Red:beInfluenced()
    local influenceRange = 30
    local blues = _.filter(self:nearActors(30), function(actor)
        return actor.color == "blue"
    end)
    if #blues > 5 then
        self.blueness = self.blueness + Actor.convertSpeed
    end
    if self.blueness > 10 then
        nomads:addMember(Blue(self.pos, self.rawR, self.level))
        self:die()
    end
end

function Red:die()
    --Timer.cancel(self.influenceHandle)
    --Timer.cancel(self.fightHandle)
    self.timer:clear()
    Actor.die(self)
end

function Red:changeJob()
    local newLevel = math.clamp(1,self.level/2,8)
    nomads:addMember(Blue(self.pos, self.rawR, newLevel))
    self:die()
end



return Red